﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/


-- --------------------------------------------
--	SP: ContactRequest_Confirm
--	Create date: 22/03/2020
--
--  DESCRIPTION
--	Confirm a contact request
--	
--	RETURNS
--	-1:		One or more parameter is missing
--	-2:		RequestID / RecipientID mismatch
-- --------------------------------------------
CREATE PROCEDURE [dbo].[ContactRequest_Confirm]
	@UserID			INT,
	@RequestID		INT
AS
BEGIN
	IF @UserID IS NULL OR @RequestID IS NULL
		RETURN -1
	
	IF NOT EXISTS(SELECT * FROM [dbo].[ContactRequest] WHERE RecipientID = @UserID AND ID = @RequestID)
		RETURN -2

	DECLARE @RequestorID	NUMERIC(10)
	SELECT @RequestorID = RequestorID FROM [dbo].[ContactRequest] WHERE ID = @RequestID

	DECLARE @MyTranCount INT = @@TRANCOUNT

	IF @MyTranCount = 0
		BEGIN TRAN

	BEGIN TRY
		UPDATE [dbo].[ContactRequest]
		SET RecipientState = 'CONFIRMED',
			RecipientLastUpdate = GETDATE()
		WHERE ID = @RequestID

		DELETE [dbo].[Contact]
		WHERE [User1ID] = @RequestorID AND [User2ID] = @UserID
				OR [User1ID] = @UserID AND [User2ID] = @RequestorID

		INSERT INTO [dbo].[Contact]([User1ID], [User2ID], [User1State], [User2State]) VALUES(@RequestorID, @UserID, 'CONFIRMED', 'CONFIRMED')

		IF @MyTranCount = 0
			COMMIT TRAN
	END TRY
	BEGIN CATCH
		IF @MyTranCount = 0
			ROLLBACK TRAN

		THROW
	END CATCH
END
	
