﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/

-- --------------------------------------------
--	SP: ContactRequest_Reject
--	Create date: 22/03/2020
--
--  DESCRIPTION
--	Reject a contact request
--	
--	RETURNS
--	-1:		One or more parameter is missing
--	-2:		RequestID / RecipientID mismatch
-- --------------------------------------------
CREATE PROCEDURE [dbo].[ContactRequest_Reject]
	@UserID			INT,
	@RequestID		INT
AS
BEGIN
	IF @UserID IS NULL OR @RequestID IS NULL
		RETURN -1
	
	IF NOT EXISTS(SELECT * FROM [dbo].[ContactRequest] WHERE RecipientID = @UserID AND ID = @RequestID)
		RETURN -2

	UPDATE [dbo].[ContactRequest]
	SET RecipientState = 'REJECTED',
		RecipientLastUpdate = GETDATE()
	WHERE ID = @RequestID

END
	
