﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/

-- --------------------------------------------
--	SP: ContactRequest_Send
--	Create date: 04/02/2020
--
--  DESCRIPTION
--	Insert a new contact request
--	
--	RETURNS
--	-1:		One or more parameter is missing
--	-2:		Invalid RequestorID
--	-3:		Invalid RecipientID
--	-4:		Contact request already exists
--	-5:		The recipient is already a contact for the requestor
-- --------------------------------------------
CREATE PROCEDURE [dbo].[ContactRequest_Send]
	@ID				INT OUTPUT,
	@RequestorID	INT,
	@RecipientID	INT
AS
BEGIN
	IF @RequestorID IS NULL OR @RecipientID IS NULL
		RETURN -1

	IF NOT EXISTS(SELECT * FROM [dbo].[User] WHERE ID = @RequestorID)
		RETURN -2

	IF NOT EXISTS(SELECT * FROM [dbo].[User] WHERE ID = @RecipientID)
		RETURN -3

	IF EXISTS(SELECT * FROM [dbo].[ContactRequest] WHERE RequestorID = @RequestorID AND RecipientID = @RecipientID AND RecipientState = 'PENDING' )
		RETURN -4

	IF EXISTS(SELECT * FROM [dbo].[Contact] WHERE ((User1ID = @RequestorID AND User2ID =  @RecipientID) 
													OR (User1ID = @RecipientID AND User2ID = @RequestorID))
													AND User1State = 'CONFIRMED' AND User2State = 'CONFIRMED')
		RETURN -5

	INSERT INTO [dbo].[ContactRequest](RequestorID, RecipientID, RequestorState, RecipientState)
	VALUES(@RequestorID, @RecipientID, 'CONFIRMED', 'PENDING')

	SET @ID = SCOPE_IDENTITY()
END
	
