﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/


-- --------------------------------------------
--	SP: User_GetContactRequests
--	Create date: 09/02/2020
--
--	DESCRIPTION
--	Get the contact requests list of the given user
--
--	RETURNS
--	-1:		One or more parameter is missing
-- --------------------------------------------
CREATE PROCEDURE [dbo].[User_GetContactRequests]
	@UserID		INT
AS
BEGIN
	IF @UserID IS NULL
		RETURN -1

	SELECT CR.ID, CR.RequestorID AS UserID, U.EMail, U.Nickname
	FROM [dbo].ContactRequest CR
	INNER JOIN [dbo].[User] U ON CR.RequestorID = U.ID
	WHERE CR.RecipientID = @UserID
			AND CR.RecipientState = 'PENDING'
	ORDER BY U.Nickname
END
