﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/


-- --------------------------------------------
--	SP: User_GetContacts
--	Create date: 09/02/2020
--
--	DESCRIPTION
--	Get the contacts list of the given user
--
--	RETURNS
--	-1:		One or more parameter is missing
-- --------------------------------------------
CREATE PROCEDURE [dbo].[User_GetContacts]
	@UserID			INT
AS
BEGIN
	IF @UserID IS NULL
		RETURN -1

	SELECT T.ID, T.UserID, T.EMail, T.Nickname, ISNULL(PENDING_MSG.MessageCount, 0) AS PendingMessages
	FROM
	(
		SELECT C.ID, C.User2ID UserID, U.EMail, U.Nickname
		FROM [dbo].Contact C
		INNER JOIN [dbo].[User] U ON C.User2ID = U.ID
		WHERE C.User1ID = @UserID 
				AND C.User1State = 'CONFIRMED'
				AND C.User2State = 'CONFIRMED'
		UNION
		SELECT C.ID, C.User1ID AS UserID, U.EMail, U.Nickname
		FROM [dbo].Contact C
		INNER JOIN [dbo].[User] U ON C.User1ID = U.ID
		WHERE C.User2ID = @UserID 
				AND C.User1State = 'CONFIRMED'
				AND C.User2State = 'CONFIRMED'
	) AS T
	LEFT JOIN (SELECT M.SenderID, COUNT(*) AS MessageCount 
				FROM [dbo].[Message] M 
				WHERE M.RecipientID = @UserID
					AND M.[State] = 'PENDING'
				GROUP BY M.SenderID
	) PENDING_MSG ON T.UserID = PENDING_MSG.SenderID
	ORDER BY Nickname
END