﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/


-- --------------------------------------------
--	SP: User_GetMessages
--	Create date: 13/02/2020
--
--	DESCRIPTION
--	Get the contacts list of messages of a given user
--
--	RETURNS
--	-1:		One or more parameter is missing
-- --------------------------------------------
CREATE PROCEDURE [dbo].[User_GetMessages]
	@UserID				INT,
	@RecipientID		INT
AS
BEGIN
	IF @UserID IS NULL
		RETURN -1

	SELECT M.ID, M.CreationDate, M.ModifyDate, M.[Message],
			M.SenderID, SND.EMail AS SenderEMail, SND.Nickname AS SenderNickName,
			M.RecipientID, REC.EMail AS RecipientEMail, REC.Nickname AS RecipientNickname, 
			M.[State]
	FROM [dbo].[Message] M
	INNER JOIN [dbo].[User] SND ON M.SenderID = SND.ID
	INNER JOIN [dbo].[User] REC ON M.RecipientID = REC.ID
	WHERE M.OwnerID = @UserID
			AND ((M.SenderID = @UserID AND M.RecipientID = @RecipientID)
					OR (M.SenderID = @RecipientID AND M.RecipientID = @UserID))
	ORDER BY M.CreationDate


	UPDATE [dbo].[Message] 
	SET [State] = 'DELIVERED' 
	WHERE SenderID = @RecipientID 
		AND RecipientID = @UserID
		AND [State] = 'PENDING'
END
