﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/


-- --------------------------------------------
--	SP: User_Login
--	Create date: 08/02/2020
--
--	DESCRIPTION
--	User login
--
--	RETURNS
--	-1:		One or more parameter is missing
--	-2:		Invalid credentials
-- --------------------------------------------
CREATE PROCEDURE [dbo].[User_Login]
	@EMail		NVARCHAR(260),
	@Password	NVARCHAR(100)
AS
BEGIN
	IF ISNULL(@EMail, '') = '' OR @Password IS NULL
		RETURN -1

	DECLARE @PasswordHash VARBINARY(MAX)
	SET @PasswordHash = HASHBYTES('SHA2_512', @Password)

	SELECT ID, EMail, Nickname 
	FROM [dbo].[User] 
	WHERE EMail = @EMail AND [Password] = @PasswordHash

	IF @@ROWCOUNT = 0
		RETURN -2
END
