﻿/*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
*****************************************************************************/


-- --------------------------------------------
--	SP: User_Search
--	Create date: 15/03/2020
--
--	DESCRIPTION
--	Show the users list, excluding those already in the contact list
--	of the caller
--
--	RETURNS
--	-1:		One or more parameter is missing
-- --------------------------------------------
CREATE PROCEDURE [dbo].[User_Search]
	@UserID				INT,
	@SearchText NVARCHAR(260)
AS
BEGIN
	IF @UserID IS NULL
		RETURN -1

	SELECT U.ID, U.Nickname, U.EMail
	FROM [dbo].[User] U
	WHERE U.ID <> @UserID
		AND ((U.EMail LIKE '%' + @SearchText + '%')
			OR (U.Nickname LIKE '%' + @SearchText + '%')
			OR @SearchText IS NULL)
		AND NOT EXISTS(SELECT * FROM [dbo].Contact C1 WHERE C1.User1ID = @UserID AND C1.User2ID = U.ID AND C1.User1State = 'CONFIRMED' AND C1.User2State = 'CONFIRMED')
		AND NOT EXISTS(SELECT * FROM [dbo].Contact C2 WHERE C2.User1ID = U.ID AND C2.User2ID = @UserID AND C2.User1State = 'CONFIRMED' AND C2.User2State = 'CONFIRMED')
	ORDER BY U.Nickname

END
