﻿CREATE TABLE [dbo].[Contact] (
    [ID]             INT          NOT NULL IDENTITY,
    [User1ID]        INT          NOT NULL,
    [User2ID]        INT          NOT NULL,
    [User1State]     VARCHAR (10) NOT NULL CHECK ([User1State] IN ('CONFIRMED', 'DELETED')),
    [User2State]     VARCHAR (10) NOT NULL CHECK ([User2State] IN ('CONFIRMED', 'DELETED')),
    [CreationDate]   DATETIME     NOT NULL DEFAULT GETDATE(),
    [User1LastUpdate]    DATETIME    NOT NULL DEFAULT GETDATE(), 
    [User2LastUpdate]    DATETIME    NOT NULL DEFAULT GETDATE(),
    CONSTRAINT [PK_Contact] PRIMARY KEY CLUSTERED ([ID] ASC),
    CONSTRAINT [FK_Contact_User1ID] FOREIGN KEY ([User1ID]) REFERENCES [dbo].[User] ([ID]),
    CONSTRAINT [FK_Contact_User2ID] FOREIGN KEY ([User2ID]) REFERENCES [dbo].[User] ([ID])
);
GO

CREATE UNIQUE INDEX [IX_Contact_UniqueContact] ON [dbo].[Contact] ([User1ID], [User2ID])
GO

CREATE INDEX [IX_Contact_User1ID] ON [dbo].[Contact] (User1ID)
GO

CREATE INDEX [IX_Contact_User2ID] ON [dbo].[Contact] (User2ID)
GO
