﻿CREATE TABLE [dbo].[ContactRequest]
(
	[ID] INT NOT NULL IDENTITY, 
    [RequestorID] INT NOT NULL, 
    [RecipientID] INT NOT NULL, 
    [RequestorState] VARCHAR(10) NOT NULL CHECK ([RequestorState] IN ('CONFIRMED')), 
    [RecipientState] VARCHAR(10) NOT NULL CHECK ([RecipientState] IN ('PENDING', 'CONFIRMED', 'REJECTED')),
    [CreationDate]          DATETIME NOT NULL DEFAULT GETDATE(),
    [RequestorLastUpdate]   DATETIME NOT NULL DEFAULT GETDATE(),
    [RecipientLastUpdate]   DATETIME NOT NULL DEFAULT GETDATE(),
    CONSTRAINT [PK_ContactRequest] PRIMARY KEY CLUSTERED ([ID] ASC),
    CONSTRAINT [FK_ContactRequest_RequestorID] FOREIGN KEY ([RequestorID]) REFERENCES [dbo].[User] ([ID]),
    CONSTRAINT [FK_ContactRequest_RecipientID] FOREIGN KEY ([RecipientID]) REFERENCES [dbo].[User] ([ID])
)
GO

CREATE INDEX [IX_ContactRequest_RequestorID] ON [dbo].[ContactRequest] (RequestorID)
GO

CREATE INDEX [IX_ContactRequest_RecipientID] ON [dbo].[ContactRequest] (RecipientID)
GO
