﻿CREATE TABLE [dbo].[Message] (
    [ID]             INT            NOT NULL IDENTITY,
    [OwnerID]        INT            NOT NULL CHECK ([OwnerID] = [SenderID] OR [OwnerID] = [RecipientID]),
    [SenderID]       INT            NOT NULL,
    [RecipientID]    INT            NOT NULL,
    [CreationDate]   DATETIME       NOT NULL DEFAULT GETDATE(),
    [ModifyDate]     DATETIME       NOT NULL DEFAULT GETDATE(),
    [Message]        NVARCHAR (250) NOT NULL,
    [State]          VARCHAR (10)   NOT NULL CHECK (([OwnerID] = [SenderID] AND [State] = 'SENT') OR ([OwnerID] = [RecipientID] AND [State] IN ('PENDING', 'DELIVERED'))), 
    CONSTRAINT [PK_Message] PRIMARY KEY CLUSTERED ([ID] ASC),
    CONSTRAINT [FK_Message_OwnerUserID] FOREIGN KEY ([OwnerID]) REFERENCES [dbo].[User] ([ID]),
    CONSTRAINT [FK_Message_RecipientUserID] FOREIGN KEY ([RecipientID]) REFERENCES [dbo].[User] ([ID]),
    CONSTRAINT [FK_Message_SenderUserID] FOREIGN KEY ([SenderID]) REFERENCES [dbo].[User] ([ID])
);
GO

CREATE INDEX [IX_Message_OwnerID] ON [dbo].[Message] (OwnerID)
GO

CREATE INDEX [IX_Message_SenderID] ON [dbo].[Message] (SenderID)
GO

CREATE INDEX [IX_Message_RecipientID] ON [dbo].[Message] (RecipientID)
GO

