﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System;
using System.Windows.Forms;
using TDP.ChatClient.Infrastructure.GUI;
using TDP.ChatLib.Messages.Core;

namespace TDP.ChatClient
{
    public partial class FrmAddContact : Form
    {
        private BindingSource _BsContacts;

        public FrmAddContact()
        {
            InitializeComponent();

            _BsContacts = new BindingSource();
        }

        private void FrmAddContact_Load(object sender, EventArgs e)
        {
            
        }

        private async void BtnSearch_Click(object sender, EventArgs e)
        {
            SearchClientResponse SearchRsp = await Common.ChatClient.SearchClientAsync(TxtFindContact.Text);

            if (!SearchRsp.Success)
            {
                WinUtils.ShowAlert("An error occurred while searching for contacts.");
                return;
            }

            _BsContacts.DataSource = SearchRsp.Contacts;
            LstContacts.ValueMember = "ID";
            LstContacts.DisplayMember = "ListBoxContactItem";
            LstContacts.DataSource = _BsContacts;

            if (SearchRsp.Contacts.Count == 0)
                WinUtils.ShowInfo("No contacts were found.");
        }

        private async void BtnConfirm_Click(object sender, EventArgs e)
        {
            if (LstContacts.SelectedIndex == -1)
            {
                WinUtils.ShowInfo("You must select a contact.");
                return;
            }

            AddClientResponse AddClientRsp = await Common.ChatClient.AddClientAsync((int)LstContacts.SelectedValue);

            if (AddClientRsp.Success)
            {
                WinUtils.ShowInfo("The request has been sent.");
                return;
            }
            else
            {
                WinUtils.ShowInfo(AddClientRsp.Message);
                return;
            }

            // The add client request has been sent, we don't have to do nothing
        }

        private void TxtFindContact_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                BtnSearch_Click(null, null);
            }
        }
    }
}
