﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System;
using System.Windows.Forms;
using TDP.BaseServices.Infrastructure.DataValidation;
using TDP.ChatClient.Infrastructure.GUI;
using TDP.ChatLib.Messages.Core;

namespace TDP.ChatClient
{
    public partial class FrmLogin : Form
    {
        public FrmLogin()
        {
            InitializeComponent();
        }

        private async void BtnCreate_Click(object sender, EventArgs e)
        {
            if (DataValidationHelper.IsEmptyString(TxtEMail.Text) 
                || !DataValidationHelper.IsValidEMail(TxtEMail.Text))
            {
                WinUtils.ShowAlert("Enter a valid EMail.");
                return;
            }
            
            if (DataValidationHelper.IsEmptyString(TxtPassword.Text))
            {
                WinUtils.ShowAlert("Enter a password.");
                return;
            }

            if (Common.ChatClient == null)
                Common.ChatClient = new ChatLib.Client.ChatClient();
     
            RegisterClientResponse RegisterRsp = await Common.ChatClient.RegisterAsync(TxtEMail.Text, TxtEMail.Text, TxtPassword.Text);

            if (RegisterRsp.Success)
            {
                Common.AuthToken = RegisterRsp.AuthToken;
                WinUtils.ShowInfo("Registration completed.");
                DialogResult = DialogResult.OK;
                Close();
            }
            else
            {
                WinUtils.ShowInfo(RegisterRsp.Message);
            }
        }

        private async void BtnLogin_Click(object sender, EventArgs e)
        {
            if (DataValidationHelper.IsEmptyString(TxtEMail.Text)
                || !DataValidationHelper.IsValidEMail(TxtEMail.Text))
            {
                WinUtils.ShowAlert("Enter a valid EMail.");
                return;
            }

            if (DataValidationHelper.IsEmptyString(TxtPassword.Text))
            {
                WinUtils.ShowAlert("Enter a password.");
                return;
            }

            if (Common.ChatClient == null)
                Common.ChatClient = new ChatLib.Client.ChatClient();

            LoginClientResponse LoginRsp = await Common.ChatClient.LoginAsync(TxtEMail.Text, TxtPassword.Text);
            
            if (LoginRsp.Success)
            {
                Common.AuthToken = LoginRsp.AuthToken;
                WinUtils.ShowInfo("Login completed.");
                DialogResult = DialogResult.OK;
                Close();
            }
            else
            {
                WinUtils.ShowInfo(LoginRsp.Message);
            }
        }
    }
}
