﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using TDP.BaseServices.Infrastructure.Configuration;
using TDP.ChatLib.Client.Infrastructure;
using TDP.ChatLib.Client.Infrastructure.Configuration;

namespace TDP.ChatLib.Client
{
    class Config
    {
        private Config()
        {

        }

        public static string ConnectIPAddress { get; private set; }
        public static int ConnectPort { get; private set; }
        public static int SendTimeout { get; private set; }
        public static int ReceiveTimeout { get; private set; }
        public static bool UseSsl { get; private set; }
        public static string SslTargetHost { get; private set; }
        public static bool IgnoreSslErrors { get; private set; }
        public static int AuthTokenMinutesToRenew { get; private set; }
        public static int AuthTokenCheckExpiringIntervalMS { get; private set; }

        public static void Init()
        {
            ConfigReader CR = new ConfigReader();
            ConnectIPAddress = CR.Get(ConfigReaderKeys.KeyConnectIPAddress, Constants.DefaultConnectIPAddress);
            ConnectPort = CR.Get(ConfigReaderKeys.KeyConnectPort, Constants.DefaultConnectPort);
            SendTimeout = CR.Get(ConfigReaderKeys.KeySendTimeout, Constants.DefaultSendTimeout);
            ReceiveTimeout = CR.Get(ConfigReaderKeys.KeyReceiveTimeout, Constants.DefaultReceiveTimeout);
            UseSsl = CR.Get(ConfigReaderKeys.KeyUseSsl, Constants.DefaultUseSsl);
            SslTargetHost = CR.Get(ConfigReaderKeys.KeySslTargetHost, Constants.DefaultSslTargetHost);
            IgnoreSslErrors = CR.Get(ConfigReaderKeys.KeyIgnoreSslErrors, Constants.DefaultIgnoreSslErrors);
            AuthTokenMinutesToRenew = CR.Get(ConfigReaderKeys.KeyAuthTokenMinutesToRenew, Constants.DefaultAuthTokenMinutesToRenew);
            AuthTokenCheckExpiringIntervalMS = CR.Get(ConfigReaderKeys.KeyAuthTokenCheckExpiringIntervalMS, Constants.DefaultAuthTokenCheckExpiringIntervalMS);
        }
    }
}
