﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System;
using System.Collections.Generic;
using TDP.ChatLib.Messages.Abstract;

namespace TDP.ChatLib.Messages.Core
{
    [Serializable]
    public class SynchronizeClientResponse : IResponseBase
    {
        public SynchronizeClientResponse()
        {
            Contacts = new List<ContactItem>();
            ContactRequestes = new List<ContactRequestItem>();
            Messages = new List<MessageItem>();
        }

        public SynchronizeClientResponse(bool success, int errorCode, string message,
                                            List<ContactItem> contacts, List<ContactRequestItem> contactRequestes, List<MessageItem> messages)
        {
            Success = success;
            ErrorCode = errorCode;
            Message = message;
            Contacts = contacts;
            ContactRequestes = contactRequestes;
            Messages = messages;
        }

        public bool Success { get; set; }
        public int ErrorCode { get; set; }
        public string Message { get; set; }

        public List<ContactItem> Contacts { get; set; }

        public List<ContactRequestItem> ContactRequestes { get; set; }

        public List<MessageItem> Messages { get; set; }
    }
}
