﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Security;
using System.Net.Sockets;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;
using TDP.BaseServices.Infrastructure.Net;

namespace TDP.ChatLib.Server
{
    class ChatClient
    {
        private Socket _Socket;
        private Stream _Stream;

        public ChatClient(Socket clientSocket, X509Certificate2 sslCertificate)
        {
            _Socket = clientSocket;

            if (sslCertificate == null)
                _Stream = new NetworkStream(clientSocket);
            else
            {
                _Stream = new SslStream(new NetworkStream(clientSocket));
                ((SslStream)_Stream).AuthenticateAsServer(sslCertificate, clientCertificateRequired: false, checkCertificateRevocation: true);
            }
        }

        public void SendObject<T>(T objectToSend)
        {
            SocketHelper.SendObject(_Stream, objectToSend);
        }

        public T ReceiveObject<T>()
        {
            return SocketHelper.ReceiveObject<T>(_Stream);
        }

        public object ReceiveObject()
        {
            return SocketHelper.ReceiveObject(_Stream);
        }

        public void Disconnect()
        {
            _Stream.Close();
            _Stream.Dispose();

            _Socket.Shutdown(SocketShutdown.Both);

            if (_Socket.Connected)
                _Socket.Disconnect(false);
            _Socket.Close();
            _Socket.Dispose();
        }
    }
}
