﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TDP.BaseServices.Infrastructure.Configuration;
using TDP.ChatLib.Server.Infrastructure;
using TDP.ChatLib.Server.Infrastructure.Configuration;

namespace TDP.ChatLib.Server
{
    class Config
    {
        private Config()
        {
            
        }

        public static string ListenIPAddress { get; private set; }
        public static int ListenPort { get; private set; }
        public static int ListenBacklog { get; private set; }
        public static int AuthTokenDurationMinutes { get; private set; }
        public static bool UseSsl { get; private set; }
        public static string Certificate { get; private set; }
        public static string CertificatePassword { get; private set; }
        public static string RSAKey { get; private set; }

        public static void Init()
        {
            ConfigReader CR = new ConfigReader();
            ListenIPAddress = CR.Get(ConfigReaderKeys.KeyChatListenIPAddress, Constants.DefaultChatListenIPAddress);
            ListenPort = CR.Get(ConfigReaderKeys.KeyChatListenPort, Constants.DefaultChatListenPort);
            AuthTokenDurationMinutes = CR.Get(ConfigReaderKeys.KeyChatAuthTokenDurationMinutes, Constants.DefaultChatAuthTokenDurationMinutes);
            UseSsl = CR.Get(ConfigReaderKeys.KeyChatUseSsl, Constants.DefaultUseSSL);
            Certificate = CR.Get(ConfigReaderKeys.KeyChatCertificate, Constants.DefaultCertificate);
            CertificatePassword = CR.Get(ConfigReaderKeys.KeyChatCertificatePassword, Constants.DefaultCertificatePassword);
            RSAKey = CR.Get(ConfigReaderKeys.KeyChatRSAKey, string.Empty);
        }
    }
}
