﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System.Collections.Generic;
using TDP.BaseServices.Infrastructure;
using TDP.ChatLib.Server.Models;

namespace TDP.ChatLib.Server.Infrastructure.ChatRepository.Abstract
{
    interface IChatRepositoryManager
    {
        MethodResult<RegisterModel> Register(string email, string nickname, string password);
        MethodResult<LoginModel> Login(string email, string password);
        MethodResult<List<ContactModel>> GetUserContacts(int userID);
        MethodResult<List<ContactRequestModel>> GetUserContactRequests(int userID);
        int SendMessage(int senderID, int recipientID, string message);
        MethodResult<List<UserModel>> SearchClient(int userID, string searchText);
        int AddClient(int requestorID, int recipientID);
        int ConfirmAddClientRequest(int userID, int requestID);
        int RejectAddClientRequest(int userID, int requestID);
        MethodResult<List<ContactRequestDetailModel>> GetContactRequestDetail(int ID);
    }
}
