﻿//*****************************************************************************
//
//  By The Dummy Programmer
//  https://www.thedummyprogrammer.com
//
//*****************************************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TDP.ChatLib.Server.Infrastructure;
using TDP.BaseServices.Infrastructure.Logging;
using TDP.BaseServices.Infrastructure.Logging.Abstract;

namespace TDP.ChatServer
{
    class Program
    {
        private static TDP.ChatLib.Server.ChatServer _ChatServer;
        private static ILogger _Log = new Logger();

        static void Main(string[] args)
        {
            Console.WriteLine("-------------------------------------------------------");
            Console.WriteLine(" THE DUMMY PROGRAMMER - CHAT SERVER ");
            Console.WriteLine("-------------------------------------------------------");
            Console.WriteLine();

            _Log.Info("Initializing server...");
            _ChatServer = new ChatLib.Server.ChatServer();
            _ChatServer.InitStarted += _ChatServer_InitStarted;
            _ChatServer.InitEnded += _ChatServer_InitEnded;
            _ChatServer.ShutdownStarted += _ChatServer_ShutdownStarted;
            _ChatServer.ShutdownEnded += _ChatServer_ShutdownEnded;

            Task TaskInit = _ChatServer.StartAsync();

            string InputText = string.Empty;
            while (InputText == string.Empty)
            {
                InputText = Console.ReadLine();
                if (InputText == "<EXIT>")
                    break;
            }

            _Log.Info("Stopping server...");
            _ChatServer.Stop();
        }

        private static void _ChatServer_InitStarted(object sender, EventArgs e)
        {
            _Log.Info("ChatServer_InitStarted()");
        }

        private static void _ChatServer_InitEnded(object sender, InitEndedEventArgs e)
        {
            _Log.Info("ChatServer_InitEnded()");
            _Log.Info("Initialization completed.");
        }

        private static void _ChatServer_ShutdownStarted(object sender, EventArgs e)
        {
            _Log.Info("ChatServer_ShutdownStarted()");
        }

        private static void _ChatServer_ShutdownEnded(object sender, EventArgs e)
        {
            _Log.Info("ChatServer_ShutdownEnded()");
        }
    }
}
